/*
 * @file main3.c
 *
 * A program using an even further extended subset of the
 * functionality of the list module. This is extra material for those
 * who can't stop loving function pointers.
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "list.h"

void
printdec(int num)
{
    printf(" %d", num);
}

void
sumup(int num, void *state)
{
    int *p = (int *) state;
    *p += num;
}

void
multup(int num, void *state)
{
    int *p = (int *) state;
    *p *= num;
}

int
main(int argc, char *argv[])
{
    struct list* my_list = NULL;
    int i;

    struct ops {
	char *opt;
	char *name;
	int init;
	void (*func)(int num, void *state);
    } ops[] = {
	{ .opt = "-s", .name = "sum", .init = 0, .func = sumup },
	{ .opt = "-p", .name = "product", .init = 1, .func = multup },
	{ .opt = NULL}
    };
    struct ops *op = NULL;

    my_list = push_front(my_list, 34);
    my_list = push_front(my_list, 18);
    my_list = push_back(my_list, 56);

    for (i = 1; i < argc; i++) {
	for (op = ops; op->opt; op++) {
	    if (strcmp(argv[i], op->opt) == 0) break;
	}
	if (! op->opt) {
	    printf("ignoring unknown '%s'\n", argv[i]);
	    continue;
	}

	printf("The %s of", op->name);
	foreach_list_simple(my_list, printdec);
	int acc = op->init;
	foreach_list(my_list, op->func, &acc);
	printf(" is %d.\n", acc);
    }
   
    dispose_list(my_list);
    return 0;
}
